---
title: PaymentRequest.onmerchantvalidation
slug: Web/API/PaymentRequest/onmerchantvalidation
tags:
  - API
  - Commerce
  - Event Handler
  - Payment Method
  - Payment Request API
  - PaymentRequest
  - Property
  - Reference
  - onmerchantvalidation
  - payment
---
<p>{{deprecated_header}}{{non-standard_header}}{{securecontext_header}}</p>

<p><span class="seoSummary">The {{domxref("PaymentRequest")}} event handler <code><strong>onmerchantvalidation</strong></code> is invoked when the {{event("merchantvalidation")}}</span> is fired, indicating that the payment handler (e.g., Apple Pay) requires the merchant to validate themselves. This is usually the first event to be fired, and the user won't be able to proceed with a payment until the merchant validate themselves.</p>

<p>This event is not be fired by all payment handlers. In particular, it's used by Apple Pay.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>paymentRequest</em>.onmerchantvalidation = <em>eventHandlerFunction</em>;</pre>

<h3 id="Value">Value</h3>

<p>An event handler function which is to be called whenever the {{event("merchantvalidation")}} event is fired at the {{domxref("PaymentRequest")}}, indicating that the payment handler requires the merchant to validate themselves as allowed to use this payment handler.</p>

<h2 id="Examples">Examples</h2>

<p>An example merchant validation handler for the {{domxref("PaymentRequest")}} object <code>request</code> looks like this:</p>

<pre class="brush: js notranslate">request.onmerchantvalidation = ev =&gt; {
  ev.complete(async () =&gt; {
    const merchantServerUrl = window.location.origin +
        '/validation?url=' + encodeURIComponent(ev.validationURL);
    // get validation data, and complete validation;
    return await fetch(merchantServerUrl).then(r =&gt; r.text());
  })
};

const response = await request.show();</pre>

<p>For more information, see {{SectionOnPage("/en-US/docs/Web/API/Payment_Request_API/Concepts", "Merchant Validation")}}.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.PaymentRequest.onmerchantvalidation")}}</p>
</div>
